Public Member Functions | Data Fields | Static Public Attributes

# NWidgetNewGRFDisplay Class Reference

Custom nested widget container for the NewGRF gui. More...

Inheritance diagram for NWidgetNewGRFDisplay:

## Public Member Functions
| NWidgetNewGRFDisplay (NWidgetBase *avs, NWidgetBase *acs, NWidgetBase *inf)
virtual void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
virtual void | Draw (const Window *w)
| Draw the widgets of the tree.
## Data Fields
NWidgetBase * | avs
| Widget with the available grfs list and buttons.
NWidgetBase * | acs
| Widget with the active grfs list and buttons.
NWidgetBase * | inf
| Info panel.
bool | editable
| Editable status of the parent NewGRF window (if `false`, drop all widgets that make the window editable).
## Static Public Attributes
static const uint | INTER_LIST_SPACING = WD_RESIZEBOX_WIDTH + 1
| Empty vertical space between both lists in the 2 column mode.
static const uint | INTER_COLUMN_SPACING = WD_RESIZEBOX_WIDTH
| Empty horizontal space between two columns.
static const uint | MAX_EXTRA_INFO_WIDTH = 150
| Maximal additional width given to the panel.
static const uint | MIN_EXTRA_FOR_3_COLUMNS = 50
| Minimal additional width needed before switching to 3 columns.

## Detailed Description

Custom nested widget container for the NewGRF gui.

Depending on the space in the gui, it uses either

- two column mode, put the acs and the avs underneath each other and the info next to it, or
- three column mode, put the avs, acs, and info each in its own column.

Definition at line 1521 of file newgrf_gui.cpp.

## Member Function Documentation

virtual void NWidgetNewGRFDisplay::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl |
| ) |  |  | `[inline, virtual]`

Assign size and position to the widget.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.
  | rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1589 of file newgrf_gui.cpp.

References acs, NWidgetBase::AssignSizePosition(), avs, ComputeMaxSize(), NWidgetBase::current_x, editable, NWidgetBase::GetHorizontalStepSize(), inf, INTER_COLUMN_SPACING, INTER_LIST_SPACING, max(), MAX_EXTRA_INFO_WIDTH, min(), MIN_EXTRA_FOR_3_COLUMNS, NWidgetBase::padding_left, NWidgetBase::padding_right, NWidgetBase::padding_top, NWidgetBase::smallest_x, NWidgetBase::smallest_y, and NWidgetBase::StoreSizePosition().

virtual void NWidgetNewGRFDisplay::Draw | ( | const Window * | w | ) | `[inline, virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1718 of file newgrf_gui.cpp.

References acs, avs, NWidgetBase::Draw(), editable, and inf.

virtual NWidgetCore* NWidgetNewGRFDisplay::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[inline, virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1708 of file newgrf_gui.cpp.

References acs, avs, NWidgetBase::current_x, NWidgetBase::current_y, editable, NWidgetBase::GetWidgetFromPos(), inf, IsInsideBS(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

virtual void NWidgetNewGRFDisplay::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[inline, virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1546 of file newgrf_gui.cpp.

References acs, avs, ComputeMaxSize(), NewGRFWindow::editable, editable, NWidgetBase::fill_x, NWidgetBase::fill_y, inf, INTER_COLUMN_SPACING, INTER_LIST_SPACING, LeastCommonMultiple(), max(), NWidgetBase::padding_bottom, NWidgetBase::padding_left, NWidgetBase::padding_right, NWidgetBase::padding_top, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

The documentation for this class was generated from the following file:

- src/newgrf_gui.cpp